﻿using System;
using System.Collections.Generic;
using System.Text;


namespace DefineRobot
{
    public class 定義Arm
    {
        public 定義Part[] 定義Parts;
        /*
            0    :上腕(ボディへの取付部)
            1    :前腕
            2    :手のひら      
			3/4  :指1
			5/6  :指2
			7/8  :指3
			9/10 :指4
			11/12:指5
        */

        // 標準カラー
        System.Drawing.Color 関節カラー   = System.Drawing.Color.Gray;
        System.Drawing.Color パーツカラー = System.Drawing.Color.White;

        // 標準サイズ
        float 関節半径 = 0.0f;
        float 長さ     = 0.0f;
        float 付根半径 = 0.0f;
        float 末端半径 = 0.0f;


        public 定義Arm()
        {
            定義Parts = new 定義Part[13];
            for (int i = 0; i < 定義Parts.Length; i++)
            {
                定義Parts[i] = null;
            }

            this.初期値設定();

        }


        public void 初期値設定()
        {
            // [0]上腕(ボディ取付部)
            関節半径 = 0.1f;
            長さ     = 1.8f;
            付根半径 = 0.06f;
            末端半径 = 0.06f;
            定義Parts[ 0] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);

            // [1]前腕
            関節半径 = 0.1f;
            長さ     = 1.6f;
            付根半径 = 0.04f;
            末端半径 = 0.04f;
            定義Parts[ 1] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);

            // [2]掌
            関節半径 = 0.06f;
            長さ     = 0.2f;
            付根半径 = 0.055f;
            末端半径 = 0.055f;
            定義Parts[2] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);


            // [3][5][7][9][11]指の付け根
            関節半径 = 0.05f;
            長さ     = 0.3f;
            付根半径 = 0.015f;
            末端半径 = 0.015f;
            定義Parts[ 3] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[ 5] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[ 7] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[ 9] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[11] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);

            // [4][6][8][10][12]指の先端
            関節半径 = 0.02f;
            長さ     = 0.25f;
            付根半径 = 0.01f;
            末端半径 = 0.01f;
            定義Parts[ 4] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[ 6] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[ 8] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[10] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
            定義Parts[12] = new 定義Part(関節カラー, パーツカラー, 関節半径, 長さ, 付根半径, 末端半径);
        }


/*

[0]上腕(ボディ取付部)
    関節部(球)
        サイズ
            半径                0.1
    パーツ部(円柱)
        サイズ
            円柱の長さ          1.8
            付根側半径(0.0以上) 0.06
            末端側半径(0.0以上)

[1]前腕
    関節部(球)
        サイズ
            半径                0.1
    パーツ部(円柱)
        サイズ
            円柱の長さ          1.6
            付根側半径(0.0以上) 0.04
            末端側半径(0.0以上)

[2]掌
    関節部(球)
        サイズ
            半径                0.06
    パーツ部(円柱)
        サイズ
            円柱の長さ          0.2
            付根側半径(0.0以上) 0.055
            末端側半径(0.0以上)

[3][5][7][9][11]指の付け根
    関節部(球)
        サイズ
            半径                0.05
    パーツ部(円柱)
        サイズ
            円柱の長さ          0.3
            付根側半径(0.0以上) 0.015
            末端側半径(0.0以上)

[4][6][8][10][12]指の先端
    関節部(球)
        サイズ
            半径                0.02
    パーツ部(円柱)
        サイズ
            円柱の長さ          0.25
            付根側半径(0.0以上) 0.01
            末端側半径(0.0以上)

*/
    }



}
