﻿using System;
using System.Collections.Generic;
using System.Text;

// メニュー.プロジェクト.参照の追加よりsystem.xml.dllを追加
using System.Xml;

namespace DefineRobot
{
    public class 定義Unit
    {

        public 定義Body     定義Body;
        public 定義Arm[]    定義Arm;

        // 共通カラー
        System.Drawing.Color 共通関節カラー = System.Drawing.Color.Gray;
        System.Drawing.Color 共通パーツカラー = System.Drawing.Color.White;

        // ポーズファイル名
        public string ポーズファイル名 = null;


        // 1.初期値設定
        // 2.xml共通Arm設定
        // 3.xml個別パーツ設定

        // ボディにテクスチャ設定
        // 指定のポーズを取る

        public 定義Unit()
		{
            定義Body = new 定義Body();

            this.定義Arm = new 定義Arm[4];
            for (int i = 0; i < this.定義Arm.Length; i++)
            {
                this.定義Arm[i] = null;
                this.定義Arm[i] = new 定義Arm();
            }
        }



        /// <summary>
        /// Arm定義情報をxml書き込み
        /// </summary>
        /// <param name="xtw"></param>
        /// <param name="ArmIndex"></param>
        private void xmlArmテスト出力( XmlTextWriter xtw, int ArmIndex )
        {
            // ArmIndexで指定されたArm情報を出力
            // ArmIndex=-1の場合、共通アーム設定として標準値を出力

            xtw.WriteComment("アーム設定");
            xtw.WriteComment("Arm index:0 ～ 3");

            if (-1 == ArmIndex)
            {
                // ------------------------------------------------------------
                // ArmIndex=-1の場合、共通アーム設定として標準値を出力
                定義Arm 標準Arm;
                標準Arm = new 定義Arm();

                xtw.WriteStartElement("Arm");
                {
                    xtw.WriteAttributeString("index", ArmIndex.ToString());
                    xtw.WriteComment("part index 0 ～ 12");

                    for (int i = 0; i < 標準Arm.定義Parts.Length; i++)
                    {
                        xtw.WriteStartElement("parts");	// 開始タグ
                        {
                            xtw.WriteAttributeString("index", i.ToString());

                            xtw.WriteStartElement("関節");	// 開始タグ
                            {
                                xtw.WriteAttributeString("r", 標準Arm.定義Parts[i].関節カラー.R.ToString());
                                xtw.WriteAttributeString("g", 標準Arm.定義Parts[i].関節カラー.G.ToString());
                                xtw.WriteAttributeString("b", 標準Arm.定義Parts[i].関節カラー.B.ToString());
                                xtw.WriteAttributeString("半径", 標準Arm.定義Parts[i].関節半径.ToString());

                            }
                            xtw.WriteEndElement();	// 終了タグ(関節部)

                            xtw.WriteStartElement("パーツ");	// 開始タグ
                            {
                                xtw.WriteAttributeString("r", 標準Arm.定義Parts[i].パーツカラー.R.ToString());
                                xtw.WriteAttributeString("g", 標準Arm.定義Parts[i].パーツカラー.G.ToString());
                                xtw.WriteAttributeString("b", 標準Arm.定義Parts[i].パーツカラー.B.ToString());
                                xtw.WriteAttributeString("長さ", 標準Arm.定義Parts[i].長さ.ToString());
                                xtw.WriteAttributeString("付根半径", 標準Arm.定義Parts[i].付根半径.ToString());
                                xtw.WriteAttributeString("末端半径", 標準Arm.定義Parts[i].末端半径.ToString());
                            }
                            xtw.WriteEndElement();	// 終了タグ(パーツ部)

                        }
                        xtw.WriteEndElement();	// 終了タグ(parts)
                    }
                }
                xtw.WriteEndElement();

            }
            else
            {
                // ------------------------------------------------------------
                // ArmIndexで指定されたArm情報を出力
                xtw.WriteStartElement("Arm");
                {
                    xtw.WriteAttributeString("index", ArmIndex.ToString());
                    xtw.WriteComment("part index 0 ～ 12");

                    for (int i = 0; i < this.定義Arm[ArmIndex].定義Parts.Length; i++)
                    {
                        xtw.WriteStartElement("parts");	// 開始タグ
                        {
                            xtw.WriteAttributeString("index", i.ToString());

                            xtw.WriteStartElement("関節");	// 開始タグ
                            {
                                xtw.WriteAttributeString("r", this.定義Arm[ArmIndex].定義Parts[i].関節カラー.R.ToString());
                                xtw.WriteAttributeString("g", this.定義Arm[ArmIndex].定義Parts[i].関節カラー.G.ToString());
                                xtw.WriteAttributeString("b", this.定義Arm[ArmIndex].定義Parts[i].関節カラー.B.ToString());
                                xtw.WriteAttributeString("半径", this.定義Arm[ArmIndex].定義Parts[i].関節半径.ToString());

                            }
                            xtw.WriteEndElement();	// 終了タグ(関節部)

                            xtw.WriteStartElement("パーツ");	// 開始タグ
                            {
                                xtw.WriteAttributeString("r", this.定義Arm[ArmIndex].定義Parts[i].パーツカラー.R.ToString());
                                xtw.WriteAttributeString("g", this.定義Arm[ArmIndex].定義Parts[i].パーツカラー.G.ToString());
                                xtw.WriteAttributeString("b", this.定義Arm[ArmIndex].定義Parts[i].パーツカラー.B.ToString());
                                xtw.WriteAttributeString("長さ", this.定義Arm[ArmIndex].定義Parts[i].長さ.ToString());
                                xtw.WriteAttributeString("付根半径", this.定義Arm[ArmIndex].定義Parts[i].付根半径.ToString());
                                xtw.WriteAttributeString("末端半径", this.定義Arm[ArmIndex].定義Parts[i].末端半径.ToString());
                            }
                            xtw.WriteEndElement();	// 終了タグ(パーツ部)

                        }
                        xtw.WriteEndElement();	// 終了タグ(parts)
                    }
                }
                xtw.WriteEndElement();


            }


        }


        /// <summary>
        /// テスト xml 出力 読込
        /// </summary>
        public void xmlモデルテスト出力( string 出力ファイル名 )
        {
            // 1.xml出力

            // 1.保存-----------------

            // ---------------
            //          http://dobon.net/vb/dotnet/file/getabsolutepath.html
            //          相対パスから絶対パスを取得、絶対パスから相対パスを取得
            Uri u1, u2;

            //ベースとなるパス (exeのフルパスを取得し、そのディレクトリ名を得る)
            u1 = new Uri(System.IO.Path.GetDirectoryName(System.Windows.Forms.Application.ExecutablePath));

            // u1をベースとした
            // "..\\..\\anime"の絶対パスを取得
            u2 = new Uri(u1, @"..\\model");

            // u2.LocalPath:ローカル オペレーティング システムでのファイル名表現を取得
//          string fileName1 = u2.LocalPath + "\\" + "MyRobotModel.xml";
            string fileName1 = u2.LocalPath + "\\" + 出力ファイル名;

            // WRITE
            XmlTextWriter xtw = new System.Xml.XmlTextWriter(fileName1, System.Text.Encoding.UTF8);
            xtw.Formatting = Formatting.Indented;	// インデントをつけて書き出す 

            // Starts a new document 
            xtw.WriteStartDocument();// バージョン "1.0" で XML 宣言を書き込み 
            xtw.WriteComment("MyRobotモデル定義ファイル");	// コメント書き込み	

            xtw.WriteComment("        Arm index ");	// コメント書き込み	
            xtw.WriteComment("        [0] 右足 ");	// コメント書き込み	
            xtw.WriteComment("        [1] 左足 ");	// コメント書き込み	
            xtw.WriteComment("        [2] 前腕 ");	// コメント書き込み	
            xtw.WriteComment("        [3] 後腕 ");	// コメント書き込み	
            xtw.WriteComment(" ");	// コメント書き込み	
            xtw.WriteComment("        parts index ");	// コメント書き込み	
            xtw.WriteComment("        [0]上腕(ボディ取付部) ");	// コメント書き込み	
            xtw.WriteComment("        [1]前腕 ");	// コメント書き込み	
            xtw.WriteComment("        [2]掌 ");	// コメント書き込み	
            xtw.WriteComment("        [3][5][7][9][11]指の付け根 ");	// コメント書き込み	
            xtw.WriteComment("        [4][6][8][10][12]指の先端 ");	// コメント書き込み	
            xtw.WriteComment(" ");	// コメント書き込み	
            xtw.WriteComment("        ボディ取付部                    指 ");	// コメント書き込み	
            xtw.WriteComment("        ●□□□□  ●□□□□  ●□□  ●□  ●□ ");	// コメント書き込み	
            xtw.WriteComment("        0           1           2       3     4 ");	// コメント書き込み	
            xtw.WriteComment("        上腕        前腕        掌      ●□  ●□ ");	// コメント書き込み	
            xtw.WriteComment("                                        5     6 ");	// コメント書き込み	
            xtw.WriteComment("                                        ●□  ●□ ");	// コメント書き込み	
            xtw.WriteComment("                                        7     8 ");	// コメント書き込み	
            xtw.WriteComment("                                        ●□  ●□ ");	// コメント書き込み	
            xtw.WriteComment("                                        9     10 ");	// コメント書き込み	
            xtw.WriteComment("                                        ●□  ●□ ");	// コメント書き込み	
            xtw.WriteComment("                                        11    12 ");	// コメント書き込み	
            xtw.WriteComment("        ●:関節部 ");	// コメント書き込み	
            xtw.WriteComment("        □:パーツ部 ");	// コメント書き込み	


            // PersonalData
            xtw.WriteStartElement("root");	// 開始タグを書き込み


            // ================================================================
            xtw.WriteComment("===================================");
            xtw.WriteComment("1.ボディテクスチャ");
            // ファイル名を指定

            xtw.WriteStartElement("テクスチャ前");	// 開始タグ
            {
                xtw.WriteAttributeString("file", this.定義Body.texture前ファイル名 );
            }
            xtw.WriteEndElement();	// 終了タグ

            xtw.WriteStartElement("テクスチャ後");
            {
                xtw.WriteAttributeString("file", this.定義Body.texture後ファイル名);
            }
            xtw.WriteEndElement();

            xtw.WriteStartElement("テクスチャ右");
            {
                xtw.WriteAttributeString("file", this.定義Body.texture右ファイル名);
            }
            xtw.WriteEndElement();

            xtw.WriteStartElement("テクスチャ左");
            {
                xtw.WriteAttributeString("file", this.定義Body.texture左ファイル名 );
            }
            xtw.WriteEndElement();


            // ================================================================
            xtw.WriteComment("===================================");
            xtw.WriteComment("2.ポーズファイル");
            xtw.WriteStartElement("ポーズファイル");
            {
                xtw.WriteAttributeString("file", this.ポーズファイル名);
            }
            xtw.WriteEndElement();



            // ================================================================
            xtw.WriteComment("===================================");
            xtw.WriteComment("3.共通パーツカラー");

            xtw.WriteStartElement("共通関節カラー");	// 開始タグ
            {
                xtw.WriteAttributeString("r", this.共通関節カラー.R.ToString() );
                xtw.WriteAttributeString("g", this.共通関節カラー.G.ToString());
                xtw.WriteAttributeString("b", this.共通関節カラー.B.ToString());
            }
            xtw.WriteEndElement();	// 終了タグ
            xtw.WriteStartElement("共通パーツカラー");	// 開始タグ
            {
                xtw.WriteAttributeString("r", this.共通パーツカラー.R.ToString());
                xtw.WriteAttributeString("g", this.共通パーツカラー.G.ToString());
                xtw.WriteAttributeString("b", this.共通パーツカラー.B.ToString());
            }
            xtw.WriteEndElement();	// 終了タグ



            // ================================================================
            xtw.WriteComment("===================================");
            xtw.WriteComment("4.共通アーム設定(index = -1の場合全てのアームに設定)");
            xmlArmテスト出力(xtw, -1);  // 初期値を出力



            // ================================================================
            xtw.WriteComment("===================================");
            xtw.WriteComment("5.個別パーツ設定");
            for (int i = 0; i < this.定義Arm.Length; i++)
            {
                xtw.WriteComment("oooooooooooooooooooooooooooooooooo");
                xmlArmテスト出力(xtw, i);   // 設定値を出力
            }

            // ================================================================
            xtw.WriteEndElement();	// 終了タグを書き込み(root)

            // EndDocument
            xtw.WriteEndDocument(); // 開いている要素または属性を閉る
            xtw.Close(); // このストリームおよび基になるストリームを閉る

            // =====================================================
            // =====================================================
        }


        /// <summary>
        /// ノード内の正の属性値を読み、floatを返す。
        /// 戻り値が-1.0fの場合は定義しない。
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        private float xml属性読込(XmlNode node, string 属性名 )
        {
            XmlAttributeCollection  attrColl;
            XmlAttribute            attr;

            float ret = -1.0f;

            if (null != node)   // ノード有り?
            {
                attrColl = node.Attributes; // ノード属性取得
                attr = (XmlAttribute)attrColl.GetNamedItem( 属性名 );
                if (null != attr)   // 属性有り?
                {
                    ret = (float)System.Convert.ToDouble(attr.Value);
                }
            }
            return ret;
        }





        /// <summary>
        /// ノード内のr,g,b属性の有無をチェック。有:true
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        private bool xmlRGB有無(XmlNode node)
        {
            bool ret = false;

            XmlAttributeCollection attrColl;

            if (null != node)   // ノード有り?
            {
                attrColl = node.Attributes; // ノードの属性を取得

                // rgb属性の有無をチェック
                if ((null != (XmlAttribute)attrColl.GetNamedItem("r")) &&
                    (null != (XmlAttribute)attrColl.GetNamedItem("g")) &&
                    (null != (XmlAttribute)attrColl.GetNamedItem("b")))
                {
                    ret = true;
                }
            }
            return ret;
        }


        
        
        /// <summary>
        /// r,g,b属性を読みColorを返す
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        private System.Drawing.Color xmlRGB読込(XmlNode node)
        {
            System.Drawing.Color ret = System.Drawing.Color.Yellow; // 戻り値の初期値:黄色
            int r = -1;
            int g = -1;
            int b = -1;

            XmlAttributeCollection  attrColl;
            XmlAttribute            attr;

            if (null != node)   // ノード有り?
            {
                attrColl = node.Attributes; // ノードの属性を取得
                attr = (XmlAttribute)attrColl.GetNamedItem("r");
                if (null != attr)   // 属性有り?
                {
                    r = System.Convert.ToInt32(attr.Value);
                }
                attr = (XmlAttribute)attrColl.GetNamedItem("g");
                if (null != attr)   // 属性有り?
                {
                    g = System.Convert.ToInt32(attr.Value);
                }
                attr = (XmlAttribute)attrColl.GetNamedItem("b");
                if (null != attr)   // 属性有り?
                {
                    b = System.Convert.ToInt32(attr.Value);
                }

                // rgbが0-255の範囲内の場合のみ色設定
                if (r > -1 && r < 256)
                    if (g > -1 && g < 256)
                        if (b > -1 && b < 256)
                            ret  = System.Drawing.Color.FromArgb(r, g, b);
            }
            return ret;
        }





        /// <summary>
        /// モデル定義xmlファイル読込
        /// </summary>
        public void xmlモデル読込(string モデルfileName)
        {
            // xml モデル定義ファイルを読み込む。

            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

            // 処理内容
            // 1.--- モデルxmlを読み込み。
            // 2.--- モデルxmlで指定されたパーツの色とサイズを読み込み。
            // 3.--- モデルxmlで指定されたポーズxml、テクスチャファイルの読込。

            // ファイルオープンダイアログを表示し、モデル定義ファイル名を取得

            // -----------------------------------------------
            try
            {
                // XML DOM READ ファイル読み込み用
                XmlDocument doc = new XmlDocument();    // DOM ドキュメント
                XmlNode node;		                // DOM ノード

                XmlAttributeCollection attrColl;
                XmlAttribute attr;

                System.Drawing.Color col;

                //ディレクトリ名の取得
                string ディレクトリ名 = System.IO.Path.GetDirectoryName(モデルfileName);

                // 2.--- アニメxmlを読み込み
                // XMLファイル ロード
                doc.Load(モデルfileName);

                // ---------------------------------------------------
                // ボディ テクスチャ ファイル名取得
                // テクスチャはモデル定義ファイルと同じディレクトリに置く。
                // ---
                node = doc.SelectSingleNode("//テクスチャ前");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    attrColl = node.Attributes; // ノード属性取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("file");
                    if (null != attr)   // 属性有り?
                    {
                        if ("" != attr.Value)
                        {
                            this.定義Body.texture前ファイル名 = ディレクトリ名 + "\\" + attr.Value;
                        }
                    }
                }

                // ---
                node = doc.SelectSingleNode("//テクスチャ後");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    attrColl = node.Attributes; // ノード属性取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("file");
                    if (null != attr)   // 属性有り?
                    {
                        if ("" != attr.Value)
                        {
                            this.定義Body.texture後ファイル名 = ディレクトリ名 + "\\" + attr.Value;
                        }
                    }
                }

                // ---
                node = doc.SelectSingleNode("//テクスチャ右");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    attrColl = node.Attributes; // ノード属性取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("file");
                    if (null != attr)   // 属性有り?
                    {
                        if ("" != attr.Value)
                        {
                            this.定義Body.texture右ファイル名 = ディレクトリ名 + "\\" + attr.Value;
                        }
                    }
                }

                // ---
                node = doc.SelectSingleNode("//テクスチャ左");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    attrColl = node.Attributes; // ノード属性取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("file");
                    if (null != attr)   // 属性有り?
                    {
                        if ("" != attr.Value)
                        {
                            this.定義Body.texture左ファイル名 = ディレクトリ名 + "\\" + attr.Value;
                        }
                    }
                }

                // ---------------------------------------------------
                // ポーズ ファイル名取得
                // ポーズファイルはモデル定義ファイルと同じディレクトリに置く。
                node = doc.SelectSingleNode("//ポーズファイル");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    attrColl = node.Attributes; // ノード属性取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("file");
                    if (null != attr)   // 属性有り?
                    {
                        if ("" != attr.Value)
                        {
                            this.ポーズファイル名 = ディレクトリ名 + "\\" + attr.Value;
                        }
                    }
                }


                // ---------------------------------------------------
                /*
                 * 設定の優先度
                 * 個別設定 > 共通アーム設定 > 共通カラー設定
                 * (設定は優先度は低い順に行う)
                 */ 


                // ---------------------------------------------------
                // 共通関節カラー取得
                node = doc.SelectSingleNode("//共通関節カラー");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    if( xmlRGB有無(node) ) // rgb属性が存在する場合のみ設定
                    {
                        this.共通関節カラー = xmlRGB読込(node);

                        // 共通カラーを全てのパーツに設定
                        for (int i = 0; i < this.定義Arm.Length; i++)
                        {
                            for (int j = 0; j < this.定義Arm[i].定義Parts.Length; j++)
                            {
                                this.定義Arm[i].定義Parts[j].関節カラー = 共通関節カラー;
                            }
                        }
                    }
                }


                // ---------------------------------------------------
                // 共通パーツカラー取得
                node = doc.SelectSingleNode("//共通パーツカラー");	// XPath 式と一致する最初の XmlNode を選択
                if (null != node)   // ノード有り?
                {
                    if (xmlRGB有無(node)) // rgb属性が存在する場合のみ設定
                    {
                        this.共通パーツカラー = xmlRGB読込(node);

                        // 共通カラーを全てのパーツに設定
                        for (int i = 0; i < this.定義Arm.Length; i++)
                        {
                            for (int j = 0; j < this.定義Arm[i].定義Parts.Length; j++)
                            {
                                this.定義Arm[i].定義Parts[j].パーツカラー = 共通パーツカラー;
                            }
                        }
                    }

                }


                // ---------------------------------------------------
                // ---------------------------------------------------
                // ---------------------------------------------------
                // ---------------------------------------------------

                /*
                 * 1.ArmIndex = -1の場合、内容を全アームに設定
                 * 2.ArmIndex = 0～3の場合、内容を対応するアームに設定
                 * ArmIndex = -1を最初に探す。
                 */

                // Armノードリスト取得
                XmlNodeList ArmNodeList = doc.SelectNodes("//Arm"); // SelectNodes:XPath 式と一致するノードリストを選択

                // 1.ArmIndex = -1の場合、内容を全アームに設定
                foreach (XmlNode ArmNode in ArmNodeList) // foreach in ループ: ノードリスト 内のノードについて全て処理 
                {
                    int ArmIndex = int.MaxValue;
                    int partsIndex = int.MaxValue;

                    // Arm index取得
                    attrColl = ArmNode.Attributes; // ノードの属性を取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("index");
                    if (null != attr)   // 属性有り?
                    {
                        ArmIndex = System.Convert.ToInt32(attr.Value);
                    }

                    // ----------------------------------------------------
                    // 共通アーム設定 (index = -1の場合全てのアームに設定)
                    if (-1 == ArmIndex)
                    {
                        // partsノードリスト取得
                        XmlNodeList partsNodeList = ArmNode.SelectNodes("parts");

                        foreach (XmlNode partsNode in partsNodeList)
                        {
                            // parts index 取得
                            attrColl = partsNode.Attributes; // ノードの属性を取得
                            attr = (XmlAttribute)attrColl.GetNamedItem("index");
                            if (null != attr)   // 属性有り?
                            {
                                partsIndex = System.Convert.ToInt32(attr.Value);
                            }

                            // partsIndexが範囲内(0-12)である場合、以下の処理を実行
                            // 定義Parts.length=13
                            if (partsIndex > -1 && partsIndex < this.定義Arm[0].定義Parts.Length)
                            {
                                // SelectSingleNode:最初の1つを取得
                                // ---------------------------
                                // 関節 ノード 取得
                                // <関節   r="128" g="128" b="128" 半径="0.1" />
                                XmlNode 関節node = partsNode.SelectSingleNode("関節");

                                if (null != 関節node)
                                {
                                    if (xmlRGB有無(関節node)) // rgb属性が存在する場合のみ設定
                                    {
                                        col = xmlRGB読込(関節node);

                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].関節カラー = col;
                                        }
                                    }


                                    // 追加!!属性"半径"が存在した場合
                                    // 属性 半径の値を取得
                                    float f = xml属性読込(関節node, "半径");

                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].関節半径 = f;
                                        }
                                    }

                                }



                                // ---------------------------
                                // パーツ ノード 取得
                                // <パーツ r="255" g="255" b="255" 長さ="1.8" 付根半径="0.06" 末端半径="0.06" />
                                XmlNode パーツnode = partsNode.SelectSingleNode("パーツ");

                                if (null != パーツnode)
                                {
                                    if (xmlRGB有無(パーツnode)) // rgb属性が存在する場合のみ設定
                                    {
                                        col = xmlRGB読込(パーツnode);

                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].パーツカラー = col;
                                        }
                                    }


                                    // 属性 長さの値を取得
                                    float f = xml属性読込(パーツnode, "長さ");
                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].長さ = f;
                                        }
                                    }

                                    // 属性 付根半径の値を取得
                                    f = xml属性読込(パーツnode, "付根半径");
                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].付根半径 = f;
                                        }
                                    }

                                    // 属性 末端半径の値を取得
                                    f = xml属性読込(パーツnode, "末端半径");

                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        for (int i = 0; i < this.定義Arm.Length; i++)
                                        {
                                            this.定義Arm[i].定義Parts[partsIndex].末端半径 = f;
                                        }
                                    }
                                }

                            } // end partsIndex が範囲内 
                        } // end foreach partsNode

                        break;  // 共通アーム設定:最初の１つ以降は読み飛ばす。
                    } // end 共通アーム設定
                    // ----------------------------------------------------
                } // end foreach ArmNode (共通アーム設定)


                // ---------------------------------------------------
                // ---------------------------------------------------

                // 2.ArmIndex = 0～3の場合、内容を対応するアームに設定
                foreach (XmlNode ArmNode in ArmNodeList) // foreach in ループ: ノードリスト 内のノードについて全て処理 
                {
                    int ArmIndex = int.MaxValue;
                    int partsIndex = int.MaxValue;

                    // Arm index取得
                    attrColl = ArmNode.Attributes; // ノードの属性を取得
                    attr = (XmlAttribute)attrColl.GetNamedItem("index");

                    if (null != attr)   // 属性有り?
                    {
                        ArmIndex = System.Convert.ToInt32(attr.Value);
                    }

                    // ----------------------------------------------------
                    // 個別パーツ設定 (ArmIndex = 0～3の場合)
                    if (ArmIndex > -1 && ArmIndex < this.定義Arm.Length)
                    {
                        // partsノードリスト取得
                        XmlNodeList partsNodeList = ArmNode.SelectNodes("parts");

                        foreach (XmlNode partsNode in partsNodeList)
                        {
                            // parts index 取得
                            attrColl = partsNode.Attributes; // ノードの属性を取得
                            attr = (XmlAttribute)attrColl.GetNamedItem("index");
                            if (null != attr)   // 属性有り?
                            {
                                partsIndex = System.Convert.ToInt32(attr.Value);
                            }

                            // partsIndexが範囲内(0-12)である場合、以下の処理を実行
                            // 定義Parts.length=13
                            if (partsIndex > -1 && partsIndex < this.定義Arm[ArmIndex].定義Parts.Length)
                            {
                                // SelectSingleNode:最初の1つを取得
                                // ---------------------------
                                // 関節 ノード 取得
                                // <関節   r="128" g="128" b="128" 半径="0.1" />
                                XmlNode 関節node = partsNode.SelectSingleNode("関節");
                                if (null != 関節node)
                                {
                                    // 関節カラー
                                    if (xmlRGB有無(関節node)) // rgb属性が存在する場合のみ設定
                                    {
                                        col = xmlRGB読込(関節node);
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].関節カラー = col;
                                    }

                                    // 関節半径
                                    float f = xml属性読込(関節node, "半径");
                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].関節半径 = f;
                                    }
                                }



                                // ---------------------------
                                // パーツ ノード 取得
                                // <パーツ r="255" g="255" b="255" 長さ="1.8" 付根半径="0.06" 末端半径="0.06" />
                                XmlNode パーツnode = partsNode.SelectSingleNode("パーツ");

                                // XPath / : ルートノード
                                // XPath //: 先祖と子孫を連結

                                if (null != パーツnode)
                                {
                                    // パーツカラー
                                    if (xmlRGB有無(パーツnode)) // rgb属性が存在する場合のみ設定
                                    {
                                        col = xmlRGB読込(パーツnode);
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].パーツカラー = col;
                                    }


                                    // 長さ
                                    float f = xml属性読込(パーツnode, "長さ");
                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].長さ = f;
                                    }

                                    // 付根半径
                                    f = xml属性読込(パーツnode, "付根半径");
                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].付根半径 = f;
                                    }

                                    // 末端半径
                                    f = xml属性読込(パーツnode, "末端半径");

                                    if (0 <= f) // 値が有効の場合のみ設定
                                    {
                                        this.定義Arm[ArmIndex].定義Parts[partsIndex].末端半径 = f;
                                    }
                                }


                            } // end partsIndex が範囲内 
                        } // end foreach partsNode
                    } // end 個別パーツ設定 (ArmIndex = 0～3の場合)


                    // ----------------------------------------------------
                } // end foreach Armノードを全て処理
                // ---------------------------------------------------
                // ---------------------------------------------------
            }
            catch (Exception e)
            {
                throw (e);
            }
            // -----------------------------------------------

            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        } // end xmlモデル読込()
    
    }
}
